%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              R O T A T I O N   S E A R C H
%
% This package contains the source code which implements the
% BnB rotation search algorithm proposed in
%
% T.-J. Chin, A. Parra Bustos, M. S. Brown and D. Suter
% Fast rotation search for real-time interactive point cloud registration
% In ACM SIGGRAPH Symposium on Interactive 3D Graphics and Games (I3D) 2014
%
% Copyright (c) 2014 Alvaro PARRA BUSTOS (aparra@cs.adelaide.edu.au.)
% School of Computer Science, The University of Adelaide, Australia
% The Australian Center for Visual Technologies
% http://cs.adelaide.edu.au/~aparra
% Please acknowledge the authors by citing the above paper in any academic
% publications that have made use of this package or part of it.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Compile rot1

mex CXXFLAGS='$CXXFLAGS -Wall -std=c++11' -lmwblas -Iinclude ...
     mex_src/rot1.cpp ...
     src/imp_rot1.cpp ...
     src/rot1_evaluator.cpp ...
     src/geometry.cpp  ...
     src/binarytree.cpp  ...
     src/interval_tree.cpp  ...
     src/util_sort.cpp  

    
